<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.alarmpoint.servicemanager.*"%>

<%@ include file="includes/mobilegatewaysession.jsp"%>

<%
//Get the updated incident from the session
ServiceManagerIncident updatedIncident = (ServiceManagerIncident)session.getAttribute("incident");
String incidentID = updatedIncident.getTextValue("IncidentID");

if(request.getParameter("cancelUpdate") != null)
{
  String status = "&message=Update Canceled";
  %>
  <jsp:forward page="<%=response.encodeURL("loadIncident.jsp?IncidentID="+incidentID+status)%>"/>
  <%
}

//Retrieve the possibly updated incident from ServiceManager
ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
ExternalServiceResponse resps;
esr.setAction("getIncident");
esr.addToken("IncidentID", incidentID);
%> 
<%@ include file="includes/sendRequest.jsp"%>
<%
if(resps.getResponse() == null)
{
  String status = "&errorMessage="+"Unable to update incident";
  %>
  <jsp:forward page="<%=response.encodeURL("updateIncident.jsp?"+status)%>"/>
  <%
}
else if(resps.getResponse() instanceof String)
{
  String status = "&errorMessage="+resps.getResponse();
  %>
  <jsp:forward page="<%=response.encodeURL("updateIncident.jsp?"+status)%>"/>
  <%
}
ServiceManagerIncident oldIncident = (ServiceManagerIncident)resps.getResponse();
%> 
<%@ include file="includes/initializeOldIncident.jsp"%>
<%
boolean hasConflict = false;
if(request.getParameter("forceUpdate") == null || "".equals(request.getParameter("forceUpdate")))
{
  %> 
  <%@ include file="includes/diff.jsp"%>
  <%
}
if(!hasConflict){
  esr = mobileGatewaySession.createExternalServiceRequest();
  esr.setAction("saveIncident");
  esr.addToken("incidentID", incidentID);
  esr.addToken("incident", updatedIncident);
  %> 
  <%@ include file="includes/sendRequest.jsp"%>
  <%
  String status = (String)resps.getResponse();
  if(status == null)
  {
    status = "&message=OK";
    %>
    <jsp:forward page="<%=response.encodeURL("loadIncident.jsp?IncidentID=" + incidentID + status + "&forceUpdate=")%>"/>
    <%
  }
  else
  {
    String tab = "";
    if(status.startsWith("Please provide an update"))
    {
      tab = "&tab=add_action";
    }
    status = "&errorMessage="+status;
    %>
    <jsp:forward page="<%=response.encodeURL("updateIncident.jsp?" + status + tab + "&forceUpdate=Update")%>"/>
    <%
  }
}
%>
