<%
int start = 0;
session.setAttribute("incidents", incidents);
if(incidents == null || incidents.isEmpty())
{
  out.print("<div class=\"msg-warning\">No Incidents Returned</div>");
}
else if(incidents.size() == 1)
{
  String id = incidents.get(0).getTextValue("IncidentID");
  %>
  <jsp:forward page="<%=response.encodeURL("loadIncident.jsp?IncidentID="+id)%>"/>
  <%
}
else
{
  %>
  <table>
    <tr>
      <th>IN#</th>
      <th>Stat</th>
      <th>Pri</th>
      <th>Title</th>
    </tr>
    <%
    if(request.getParameter("page") != null)
      start = RESULTS_PER_PAGE * Integer.valueOf(request.getParameter("page"));
    int end = start+RESULTS_PER_PAGE;
    if(incidents.size() < end)
      end = incidents.size();
    Collection<ServiceManagerIncident> list = incidents.subList(start, end);
    for(ServiceManagerIncident incident : list)
    {
      String id = incident.getTextValue("IncidentID");
      String status = incident.getTextValue("Status");
      if("Work in progress".equalsIgnoreCase(status))
        status = "WIP";
      else if("Pending other".equalsIgnoreCase(status))
        status = "Pending";
      String priority = incident.getTextValue("Urgency");
      String title = incident.getTextValue("Title");
      String link = "loadIncident.jsp?IncidentID=" + id;
      String encodedLink = response.encodeURL(link);
    %>
    <tr>
      <td><a href="<%=encodedLink%>"><%=id%></a></td>
      <td><%=status%></td>
      <%
      if("1".equals(priority))
        out.print("<td class=\"sev-critical\">Critical</td>");
      else if("2".equals(priority))
        out.print("<td class=\"sev-high\">High</td>");
      else if("3".equals(priority))
        out.print("<td class=\"sev-average\">Average</td>");
      else if("4".equals(priority))
        out.print("<td class=\"sev-low\">Low</td>");
      else
        out.print("<td></td>");
      %>
      <td><%=title%></td>
    </tr>
    <%
    }
    %>
  </table>
  <%
  int count = 0;
  for(int i = 0; i < incidents.size(); i+=RESULTS_PER_PAGE)
  {
    if(i == start)
      out.println(count+1);
    else
      out.println("<a href=\""+response.encodeURL(pageURL+"?page="+count)+"\">"+(count+1)+"</a>");
    count++;
  }
}
%>
