<%
//Note: These fields must be specified in the same order as in the wsdl and must have the correct default value specified.
Map<String, Object> newFields = new LinkedHashMap<String, Object>();
newFields.put("IncidentID", "");
newFields.put("Category", "");
newFields.put("OpenTime", "");
newFields.put("OpenedBy", "");
newFields.put("Urgency", "");
newFields.put("UpdatedTime", "");
newFields.put("AssignmentGroup", "");
newFields.put("ClosedTime", "");
newFields.put("ClosedBy", "");
newFields.put("ClosureCode", "");
newFields.put("AffectedCI", "");
newFields.put("Description", new ArrayList<String>());
newFields.put("Solution", new ArrayList<String>());
newFields.put("Assignee","");
newFields.put("Contact", "");
newFields.put("JournalUpdates", new ArrayList<String>());
newFields.put("AlertStatus", "");
newFields.put("ContactLastName", "");
newFields.put("ContactFirstName", "");
newFields.put("Company", "");
newFields.put("Title", "");
newFields.put("TicketOwner", "");
newFields.put("UpdatedBy", "");
newFields.put("Status", "");
newFields.put("Area", "");
newFields.put("SLAAgreementID", "");
newFields.put("SiteCategory", "");
newFields.put("Subarea", "");
newFields.put("ProblemType", "");
newFields.put("ResolutionFixTye", "");
newFields.put("Location", "");
newFields.put("explanation", new ArrayList<String>());
newFields.put("Impact", "");
newFields.put("folder", "");
newFields.put("Service", "");
newFields.put("PriorityCode", "");
incident.addFields(newFields);

//Add all the possible list values to the incident
%>
<%@include file="loadLists.jsp"%>
<%

//Add the values for the IMTicketStatus field
incident.addList("Status", Arrays.asList(new String[]{ 
  "Open",
  "Closed", 
  "Pending Other", 
  "Referred",
  "Replaced Problem",
  "Resolved",
  "Accepted",
  "Rejected",
  "Work In Progress", 
  "Pending Customer", 
  "Pending Vendor",
  "Suspended"}));

incident.addList("ClosureCode", (Collection)listValues.get("ClosureCode"));

//Add the value and display values for the Severity field
Map<String, String> urgency = new LinkedHashMap<String, String>();
urgency.put("1", "1 - Critical");
urgency.put("2", "2 - High");
urgency.put("3", "3 - Average");
urgency.put("4", "4 - Low");
incident.addList("Urgency", urgency);

//Add the value and display values for the InitialImpact field
Map<String, String> impact = new LinkedHashMap<String, String>();
impact.put("1", "1 - Enterprise");
impact.put("2", "2 - Site/Dept");
impact.put("3", "3 - Multi Users");
impact.put("4", "4 - User");
incident.addList("Impact", impact);

//Add the value and display values for the Severity field
Map<String, String> priorityCode = new LinkedHashMap<String, String>();
priorityCode.put("1", "1 - Critical");
priorityCode.put("2", "2 - High");
priorityCode.put("3", "3 - Average");
priorityCode.put("4", "4 - Low");
incident.addList("PriorityCode", priorityCode);
%>
